Attribute VB_Name = "M_API_Declares"
  Option Explicit
  ' demo project showing how to use the API functions to create a
  ' background image for a MDI form.
  ' by Bryan Stafford of New Vision Software - newvision@mvps.org
  ' this demo is released into the public domain "as is" without
  ' warranty or guaranty of any kind.  In other words, use at
  ' your own risk.


  Public Const API_FALSE As Long = 0&
  Public Const API_TRUE As Long = 1&

  Public Const GW_HWNDNEXT As Long = 2&
  Public Const GW_CHILD As Long = 5&

  Public Const GWL_STYLE As Long = (-16&)

  Public Const RASTERCAPS As Long = 38&
  Public Const SIZEPALETTE As Long = 104&
  Public Const RC_PALETTE As Long = &H100&

  Public Const WS_VSCROLL As Long = &H200000
  Public Const WS_HSCROLL As Long = &H100000

  Public Const SM_CXVSCROLL As Long = 2&
  Public Const SM_CYHSCROLL As Long = 3&

  Public Const SRCCOPY As Long = &HCC0020
  Public Const SRCPAINT As Long = &HEE0086
  Public Const SRCAND As Long = &H8800C6
  Public Const NOTSRCCOPY As Long = &H330008

  Public Type RECT
    left As Long
    top As Long
    right As Long
    bottom As Long
  End Type

  Public Type POINTL
    x As Long
    y As Long
  End Type

  Public Type PALETTEENTRY
    peRed As Byte
    peGreen As Byte
    peBlue As Byte
    peFlags As Byte
  End Type
  
  Public Type LOGPALETTE256
    palVersion As Integer
    palNumEntries As Integer
    palPalEntry(255) As PALETTEENTRY
  End Type
  
  Public Type BITMAP
    bmType As Long
    bmWidth As Long
    bmHeight As Long
    bmWidthBytes As Long
    bmPlanes As Integer
    bmBitsPixel As Integer
    bmBits As Long
  End Type

  Public Type GUID
    Data1 As Long
    Data2 As Integer
    Data3 As Integer
    Data4(7) As Byte
  End Type
  
  Public Type PICTDESC_BMP
    Size As Long
    Type As Long
    hBmp As Long
    hPal As Long
    Reserved As Long
  End Type

  Public Declare Function BitBlt Lib "gdi32" (ByVal hDestDC&, ByVal x&, ByVal y&, ByVal nWidth&, ByVal nHeight&, ByVal hSrcDC&, ByVal xSrc&, ByVal ySrc&, ByVal dwRop&) As Long
  Public Declare Function StretchBlt Lib "gdi32" (ByVal hDC&, ByVal x&, ByVal y&, ByVal nWidth&, ByVal nHeight&, ByVal hSrcDC&, ByVal xSrc&, ByVal ySrc&, ByVal nSrcWidth&, ByVal nSrcHeight&, ByVal dwRop&) As Long

  Public Declare Function CreateBitmap Lib "gdi32" (ByVal nWidth&, ByVal nHeight&, ByVal nPlanes&, ByVal nBitCount&, lpBits As Any) As Long
  Public Declare Function CreateCompatibleBitmap Lib "gdi32" (ByVal hDC&, ByVal nWidth&, ByVal nHeight&) As Long
  Public Declare Function CreateCompatibleDC Lib "gdi32" (ByVal hDC&) As Long
  Public Declare Function CreatePalette Lib "gdi32" (lpLogPalette As LOGPALETTE256) As Long
  
  Public Declare Function SetBkColor Lib "gdi32" (ByVal hDC&, ByVal crColor&) As Long

  Public Declare Function GetObjectAPI Lib "gdi32" Alias "GetObjectA" (ByVal hObject&, ByVal nCount&, lpObject As Any) As Long
  Public Declare Function SelectObject Lib "gdi32" (ByVal hDC&, ByVal hObject&) As Long
  
  Public Declare Function GetDC Lib "user32" (ByVal hWnd&) As Long
  Public Declare Function ReleaseDC Lib "user32" (ByVal hWnd&, ByVal hDC&) As Long
  Public Declare Function SaveDC Lib "gdi32" (ByVal hDC&) As Long
  Public Declare Function RestoreDC Lib "gdi32" (ByVal hDC&, ByVal nSavedDC&) As Long
  Public Declare Function DeleteDC Lib "gdi32" (ByVal hDC&) As Long
  Public Declare Function DeleteObject Lib "gdi32" (ByVal hObject&) As Long
  
  Public Declare Function GetDeviceCaps Lib "gdi32" (ByVal hDC&, ByVal iCapabilitiy&) As Long
  Public Declare Function GetSystemPaletteEntries Lib "gdi32" (ByVal hDC&, ByVal wStartIndex&, ByVal wNumEntries&, lpPaletteEntries As PALETTEENTRY) As Long
  Public Declare Function OleCreatePictureIndirect Lib "olepro32.dll" (PicDesc As PICTDESC_BMP, RefIID As GUID, ByVal fPictureOwnsHandle&, IPic As IPicture) As Long
  Public Declare Function RealizePalette Lib "gdi32" (ByVal hDC&) As Long
  Public Declare Function SelectPalette Lib "gdi32" (ByVal hDC&, ByVal hPalette&, ByVal bForceBackground&) As Long

  Public Declare Function GetClientRect Lib "user32" (ByVal hWnd&, lpRect As RECT) As Long

  Public Declare Function LoadBitmapBynum Lib "user32" Alias "LoadBitmapA" (ByVal hInstance&, ByVal lpBitmapName&) As Long

  Public Declare Function GetWindowLong Lib "user32" Alias "GetWindowLongA" (ByVal hWnd&, ByVal nIndex&) As Long
  Public Declare Function GetWindow Lib "user32" (ByVal hWnd&, ByVal wCmd&) As Long

  Public Declare Function LoadLibrary Lib "kernel32" Alias "LoadLibraryA" (ByVal lpLibFileName$) As Long
  Public Declare Function FreeLibrary Lib "kernel32" (ByVal hLibModule&) As Long

  Public Declare Function GetSystemMetrics Lib "user32" (ByVal nIndex&) As Long

  Public Declare Function GetClassName Lib "user32" Alias "GetClassNameA" (ByVal hWnd&, ByVal lpClassName$, ByVal nMaxCount&) As Long
  Public Declare Function FindWindowEx Lib "user32" Alias "FindWindowExA" (ByVal hWndParent&, ByVal hWndChildAfter&, ByVal lpClassName$, ByVal lpWindowName$) As Long

  Public Declare Function InvalidateRect Lib "user32" (ByVal hWnd&, lpRect As RECT, ByVal bErase&) As Long

